#include <sys/wait.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define READ_END 0
#define WRITE_END 1

#define WORDSIZE 50
#define LINESIZE 256

struct cypher{
    char first[WORDSIZE];
    char second[WORDSIZE];

    // If word == first then switch to second
    // If word == second then switch to first
};

int main(int argc, char* argv[]){

    //check if two or four arguments are present

    if (argc != 1 || stdin == NULL) {
        printf("usage: cypher < file_to_be_encripted [> destination_file]\n");
        return EXIT_FAILURE;
    }
    else if((fseek(stdin, 0, SEEK_END), ftell(stdin)) <= 0){
        printf("A file is needed as input!\n");
        printf("usage: cypher < file_to_be_encripted [> destination_file]\n");
        exit(EXIT_FAILURE);
    }
    

    fseek(stdin, 0, SEEK_SET);

    FILE *fcypher = fopen("cypher.txt", "r");

    struct cypher list[50];
    char temp[WORDSIZE];
    int i=0, ccount = 0, lcount=0;
    char c;

    if(fcypher == NULL){
        printf("Error opening the cypher file\nMake sure you have a file named 'cypher.txt'\n");
        return EXIT_FAILURE;
    }
    else{
        memset(temp, 0, WORDSIZE);
        /* store words to be replaced and their replacements from the cypher file */
        c = fgetc(fcypher);
        while(!feof(fcypher)){
            
            if(c == ' '){
                strncpy(list[i].first, temp, ccount-1);
                memset(temp, 0, WORDSIZE);
                ccount = 0;
            }
            else if(c == '\n'){
                strncpy(list[i].second, temp, ccount-1);
                lcount++;
                memset(temp, 0, WORDSIZE);
                i++;
                ccount = 0;
            }
            else{
                strncat(temp, &c, 1);
                ccount++;
            }

            c = fgetc(fcypher);

        }

    }

    /* substitute words from file given to stdout*/
    char output[2500];
    memset(temp, 0, WORDSIZE);
    int found;
    int ocount = 0;
    ccount = 0;

    c = fgetc(stdin);

    while (!feof(stdin)) {
        found = 0;

        if(c == ' ' || c == '.' || c == '?' || c == '!'|| c == ',' || c == ';' || c == '\n' || c == ':'){

            for(int k=0; k < lcount; k++){
                if(strncmp(temp, list[k].first, strlen(list[k].first)) == 0){
                    strncat(output, list[k].second, strlen(list[k].second));
                    found = 1;
                    break;
                }
                else if(strncmp(temp, list[k].second, strlen(list[k].second)) == 0){
                    strncat(output, list[k].first, strlen(list[k].first));
                    found = 1;
                    break;
                }
            }
            
            if(found == 0){
                strncat(output, temp, strlen(temp));
            }

            strncat(output, &c, 1);
            memset(temp, 0, WORDSIZE);
            ccount = 0;
        }
        else{
            strncat(temp, &c, 1);
            ccount++;
        }       

        c = fgetc(stdin);
    }

    fprintf(stdout, "%s", output);


    return EXIT_SUCCESS;
}